package com.dvp.tutoriel.fibonacci;


public class MaCalculette2 implements Calculette {

	private final static double NOMBRE_OR = 1.61803398874989;
	private final static double RACINE_5 = 2.236067977499;

	public Long fibonacci(Integer n) {
		// REGLE RG024.4
		if (n <= 0) {
			throw new IllegalArgumentException("On ne calcule que pour des nombres positifs");
		}

		// REGLE RG024.1 : f(1) = 1
		// REGLE RG024.2 : f(2) = 1
		if (n == 1 || n == 2) {
			return 1L;
		}

		final double nominateur = Math.pow(NOMBRE_OR, n);

		final double result = nominateur / RACINE_5;
		return Math.round(result);
	}

}
