package com.dvp.tutoriel.fibonacci;

import java.util.Map;

public class MaCalculette4 implements Calculette {

	private static Map<Integer, Long> map;

	// Singleton (initialisation directe)
	private static MaCalculette4 instance = new MaCalculette4();
	
	private MaCalculette4 () {
		FibonacciDao dao = new FibonacciDao();
		map = dao.charger();
	}
	
	public static synchronized MaCalculette4 getInstance() {
		return instance;
	}
	
	@Override
	public Long fibonacci(Integer n) {

		// REGLE RG024.4
		if (n <= 0) {
			throw new IllegalArgumentException("On ne calcule que pour des nombres positifs");
		}

		// REGLE RG024.1 : f(1) = 1
		// REGLE RG024.2 : f(2) = 1
		if (n == 1 || n == 2) {
			return 1L;
		}

		// REGLE RG024.5
		// REGLE RG024.6
		Long valeur = map.get(n);
		if (valeur != null) {
			return valeur;
		}

		// REGLE RG024.3.x
		valeur = fibonacci(n - 1) + fibonacci(n - 2);
		map.put(n, valeur);
		return valeur;

	}

}
